/**  Little program for color transfer
*
* @author
*   Gabriel Zachmann, Sep 2006
*
* @bug
*   I'm sure there is still some bugs left ....
**/

// Bearbeitet von:
//  Markus Kramer   (342195)
//  Marcus Petersen (341572)
//  Daniel Mohr

#include <math.h>

#include "histogram.h"

Histogram::Histogram(QWidget *parent)
: QWidget(parent)
, m_numBins(0)
, m_pHisto(0)
{
}

Histogram::~Histogram()
{
	// nothing to do yet
}

void Histogram::paintEvent(QPaintEvent *)
{
	if ( 0 != m_pHisto )
	{
		QPainter painter(this);

		QRect vp(0,0,width(),height());
		QPoint start = vp.topLeft();
		QPoint end = vp.bottomRight();
		QPoint size(end-start);
		float blockWidth = static_cast<float>(size.x())/m_numBins;
		QColor color[3] = { QColor::fromRgb(255,0,0), QColor::fromRgb(0,255,0), QColor::fromRgb(0,0,255)};
		for ( int c = 0; c < 3; c++)
		{
			const int *histo = m_pHisto[c];
			painter.setPen(color[c]);
			if ( m_maxValues[c] > 0) // if all entries zero, nothing to draw
			{
				int heightLast = (size.y()*histo[0])/m_maxValues[c];
				for ( int x = 1; x < m_numBins; x++ )
				{
					int height = (size.y()*histo[x])/m_maxValues[c];
					painter.drawLine(blockWidth*x,end.y()-heightLast,blockWidth*x+blockWidth,end.y()-height);
					heightLast = height;
				}
			}

		}
	}
}

void Histogram::computeMaxValue()
{
	for ( int c = 0; c < 3; c++)
	{
		m_maxValues[c] = 0;
			for( int i = 0; i < m_numBins; i++)
				if ( m_pHisto[c][i] > m_maxValues[c])
					m_maxValues[c] = m_pHisto[c][i];
	}
}

